
package BCE;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;


public class Analysis {
    
    /*
    * Aggregates solution statistics for BCD
    */
    public static void aggregateDataDeletion(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();

        int totalComponents = 0;
        int unsolvedComponents = 0;
        int totalBlackVerts = 0;
        int totalWhiteVerts = 0;
        int totalEdges = 0;
        int totalTime = 0;
        int totalMods = 0;
        int totalClusters = 0;
        int totalSingletons = 0;
        int totalIsoEdges = 0;
        int totalMonoBlack = 0;
        int totalMonoWhite = 0;
        int totalDomBlack = 0;
        int totalDomWhite = 0;
        
        try {
            FileReader fileReader = new FileReader("res/deletion_results/" + path);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            for(String line; (line = bufferedReader.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!(words.length==0) && !words[0].contains("%")){  // % signals comments in data sets
                    totalComponents++;
                    if(words[3].equals("yes")){
                        System.out.println(words[0]);
                        totalBlackVerts = totalBlackVerts + Integer.parseInt(words[0]);
                        System.out.println(words[1]);
                        totalWhiteVerts = totalWhiteVerts + Integer.parseInt(words[1]);
                        System.out.println(words[2]);
                        totalEdges = totalEdges + Integer.parseInt(words[2]);
                        System.out.println(words[4]);
                        totalTime = totalTime + Integer.parseInt(words[4]);
                        System.out.println(words[5]);
                        totalMods = totalMods + Integer.parseInt(words[5]);
                        System.out.println(words[6]);
                        totalClusters = totalClusters + Integer.parseInt(words[6]);
                        System.out.println(words[7]);
                        totalSingletons = totalSingletons + Integer.parseInt(words[7]);
                        System.out.println(words[8]);
                        totalIsoEdges = totalIsoEdges + Integer.parseInt(words[8]);
                        System.out.println(words[9]);
                        totalMonoBlack = totalMonoBlack + Integer.parseInt(words[9]);
                   // words[10] contains accidental space
                        System.out.println(words[11]);
                        totalMonoWhite = totalMonoWhite + Integer.parseInt(words[11]);
                        System.out.println(words[12]);
                        totalDomBlack = totalDomBlack + Integer.parseInt(words[12]);
                        System.out.println(words[13]);
                        totalDomWhite = totalDomWhite + Integer.parseInt(words[13]);
                    }
                    else {
                        unsolvedComponents++;
                    }
                }
            }
            
            ArrayList<String> results = new ArrayList();
            
            results.add("Total Components: "+totalComponents);
            results.add("Unsolved Components: "+unsolvedComponents);
            results.add("Total Black Vertices: "+totalBlackVerts);
            results.add("Total White Vertices: "+totalWhiteVerts);
            results.add("Total Edges: "+totalEdges);
            results.add("Total Time: "+totalTime);
            results.add("Total Mods: "+totalMods);
            results.add("Total Clusters: "+totalClusters);
            results.add("Total Singletons: "+totalSingletons);
            results.add("Total IsolatedEdges: "+totalIsoEdges);
            results.add("Total MonoBlack Clusters: "+totalMonoBlack);
            results.add("Total MonoWhite Clusters: "+totalMonoWhite);
            results.add("Total DomBlack Clusters: "+totalDomBlack);
            results.add("Total DomWhite Clusters: "+totalDomWhite);
                                
            
            String aggregatedResultOutput = "res/deletion_results/aggregatedResults_" + path + "_deletion";
            fileWriter.writeToFile(aggregatedResultOutput, results);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
    
    
    /*
    * Aggregates solution statistics for BCD for components solved by both variants
    */  
     public static void aggregateFilteredDataDeletion(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();

        int totalComponents = 0;
        int unsolvedComponents = 0;
        int totalBlackVerts = 0;
        int totalWhiteVerts = 0;
        int totalEdges = 0;
        int totalTime = 0;
        int totalMods = 0;
        int totalClusters = 0;
        int totalSingletons = 0;
        int totalIsoEdges = 0;
        int totalMonoBlack = 0;
        int totalMonoWhite = 0;
        int totalDomBlack = 0;
        int totalDomWhite = 0;
        
        try {
            FileReader fileReader = new FileReader("res/filtered_results/deletion_results/" + path);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            for(String line; (line = bufferedReader.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!(words.length==0) && !words[0].contains("%")){  // % signals comments in data sets
                    totalComponents++;
                    if(words[3].equals("yes")){
                        System.out.println(words[0]);
                        totalBlackVerts = totalBlackVerts + Integer.parseInt(words[0]);
                        System.out.println(words[1]);
                        totalWhiteVerts = totalWhiteVerts + Integer.parseInt(words[1]);
                        System.out.println(words[2]);
                        totalEdges = totalEdges + Integer.parseInt(words[2]);
                        System.out.println(words[4]);
                        totalTime = totalTime + Integer.parseInt(words[4]);
                        System.out.println(words[5]);
                        totalMods = totalMods + Integer.parseInt(words[5]);
                        System.out.println(words[6]);
                        totalClusters = totalClusters + Integer.parseInt(words[6]);
                        System.out.println(words[7]);
                        totalSingletons = totalSingletons + Integer.parseInt(words[7]);
                        System.out.println(words[8]);
                        totalIsoEdges = totalIsoEdges + Integer.parseInt(words[8]);
                        System.out.println(words[9]);
                        totalMonoBlack = totalMonoBlack + Integer.parseInt(words[9]);
                        System.out.println(words[10]);
                        totalMonoWhite = totalMonoWhite + Integer.parseInt(words[10]);
                        System.out.println(words[11]);
                        totalDomBlack = totalDomBlack + Integer.parseInt(words[11]);
                        System.out.println(words[12]);
                        totalDomWhite = totalDomWhite + Integer.parseInt(words[12]);
                    }
                    else {
                        unsolvedComponents++;
                    }
                }
            }
            
            ArrayList<String> results = new ArrayList();
            
            results.add("Total Components: "+totalComponents);
            results.add("Unsolved Components: "+unsolvedComponents);
            results.add("Total Black Vertices: "+totalBlackVerts);
            results.add("Total White Vertices: "+totalWhiteVerts);
            results.add("Total Edges: "+totalEdges);
            results.add("Total Time: "+totalTime);
            results.add("Total Mods: "+totalMods);
            results.add("Total Clusters: "+totalClusters);
            results.add("Total Singletons: "+totalSingletons);
            results.add("Total IsolatedEdges: "+totalIsoEdges);
            results.add("Total MonoBlack Clusters: "+totalMonoBlack);
            results.add("Total MonoWhite Clusters: "+totalMonoWhite);
            results.add("Total DomBlack Clusters: "+totalDomBlack);
            results.add("Total DomWhite Clusters: "+totalDomWhite);
                                
            
            String aggregatedResultOutput = "res/filtered_results/deletion_results/aggregatedResults_filtered_" + path + "_deletion";
            fileWriter.writeToFile(aggregatedResultOutput, results);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
    
    
    
    
    /*
    * Aggregates solution statistics for BCE
    */   
  public static void aggregateDataEditing(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();

        int totalComponents = 0;
        int unsolvedComponents = 0;
        int totalBlackVerts = 0;
        int totalWhiteVerts = 0;
        int totalEdges = 0;
        int totalTime = 0;
        int totalDeletions = 0;
        int totalInsertions = 0;
        int totalClusters = 0;
        int totalSingletons = 0;
        int totalIsoEdges = 0;
        int totalMonoBlack = 0;
        int totalMonoWhite = 0;
        int totalDomBlack = 0;
        int totalDomWhite = 0;
        int errorComponents = 0;
        
        try {
            FileReader fileReader = new FileReader("res/editing_results/" + path);
            System.out.println(path);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            for(String line; (line = bufferedReader.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!words[0].contains("%")){  // % signals comments in data sets
                    if(!(words.length==0) && !(words.length==1)){
                        totalComponents++;
                        if(words[3].equals("yes")){
                            System.out.println(words[0]);
                            totalBlackVerts = totalBlackVerts + Integer.parseInt(words[0]);

                            System.out.println(words[1]);
                            totalWhiteVerts = totalWhiteVerts + Integer.parseInt(words[1]);

                            System.out.println(words[2]);
                            totalEdges = totalEdges + Integer.parseInt(words[2]);

                            System.out.println(words[4]);
                            totalTime = totalTime + Integer.parseInt(words[4]);

                            System.out.println(words[5]);
                            totalDeletions = totalDeletions + Integer.parseInt(words[5]);

                            System.out.println(words[6]);
                            totalInsertions = totalInsertions + Integer.parseInt(words[6]);

                            System.out.println(words[7]);
                            totalClusters = totalClusters + Integer.parseInt(words[7]);

                            System.out.println(words[8]);
                            totalSingletons = totalSingletons + Integer.parseInt(words[8]);

                            System.out.println(words[9]);
                            totalIsoEdges = totalIsoEdges + Integer.parseInt(words[9]);

                            System.out.println(words[10]);
                            totalMonoBlack = totalMonoBlack + Integer.parseInt(words[10]);

                            System.out.println(words[11]);
                            totalMonoWhite = totalMonoWhite + Integer.parseInt(words[11]);

                            System.out.println(words[12]);
                            totalDomBlack = totalDomBlack + Integer.parseInt(words[12]);

                            System.out.println(words[13]);
                            totalDomWhite = totalDomWhite + Integer.parseInt(words[13]);
                        } else {
                            unsolvedComponents++;
                        }
                    } else {
                        errorComponents++;
                    }
                }
            }
            
            ArrayList<String> results = new ArrayList();
            
            results.add("Total Components: "+totalComponents);
            results.add("Unsolved Components: "+unsolvedComponents);
            results.add("Total Black Vertices: "+totalBlackVerts);
            results.add("Total White Vertices: "+totalWhiteVerts);
            results.add("Total Edges: "+totalEdges);
            results.add("Total Time: "+totalTime);
            results.add("Total Deletions: "+totalDeletions);
            results.add("Total Insertions: "+totalInsertions);
            results.add("Total Clusters: "+totalClusters);
            results.add("Total Singletons: "+totalSingletons);
            results.add("Total IsolatedEdges: "+totalIsoEdges);
            results.add("Total MonoBlack Clusters: "+totalMonoBlack);
            results.add("Total MonoWhite Clusters: "+totalMonoWhite);
            results.add("Total DomBlack Clusters: "+totalDomBlack);
            results.add("Total DomWhite Clusters: "+totalDomWhite);
            results.add("Error Components: "+errorComponents);
                                
            
            String aggregatedResultOutput = "res/editing_results/aggregatedResults_" + path + "_editing";
            fileWriter.writeToFile(aggregatedResultOutput, results);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
    
  
    /*
    * Aggregates solution statistics for BCE for components solved by both variants
    */  
   public static void aggregateFilteredDataEditing(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();

        int totalComponents = 0;
        int unsolvedComponents = 0;
        int totalBlackVerts = 0;
        int totalWhiteVerts = 0;
        int totalEdges = 0;
        int totalTime = 0;
        int totalDeletions = 0;
        int totalInsertions = 0;
        int totalClusters = 0;
        int totalSingletons = 0;
        int totalIsoEdges = 0;
        int totalMonoBlack = 0;
        int totalMonoWhite = 0;
        int totalDomBlack = 0;
        int totalDomWhite = 0;
        int errorComponents = 0;
        
        try {
            FileReader fileReader = new FileReader("res/filtered_results/editing_results/" + path);
            System.out.println(path);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            for(String line; (line = bufferedReader.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!words[0].contains("%")){  // % signals comments in data sets
                    if(!(words.length==0) && !(words.length==1)){
                        totalComponents++;
                        if(words[3].equals("yes")){
                            System.out.println(words[0]);
                            totalBlackVerts = totalBlackVerts + Integer.parseInt(words[0]);

                            System.out.println(words[1]);
                            totalWhiteVerts = totalWhiteVerts + Integer.parseInt(words[1]);

                            System.out.println(words[2]);
                            totalEdges = totalEdges + Integer.parseInt(words[2]);

                            System.out.println(words[4]);
                            totalTime = totalTime + Integer.parseInt(words[4]);

                            System.out.println(words[5]);
                            totalDeletions = totalDeletions + Integer.parseInt(words[5]);

                            System.out.println(words[6]);
                            totalInsertions = totalInsertions + Integer.parseInt(words[6]);

                            System.out.println(words[7]);
                            totalClusters = totalClusters + Integer.parseInt(words[7]);

                            System.out.println(words[8]);
                            totalSingletons = totalSingletons + Integer.parseInt(words[8]);

                            System.out.println(words[9]);
                            totalIsoEdges = totalIsoEdges + Integer.parseInt(words[9]);

                            System.out.println(words[10]);
                            totalMonoBlack = totalMonoBlack + Integer.parseInt(words[10]);

                            System.out.println(words[11]);
                            totalMonoWhite = totalMonoWhite + Integer.parseInt(words[11]);

                            System.out.println(words[12]);
                            totalDomBlack = totalDomBlack + Integer.parseInt(words[12]);

                            System.out.println(words[13]);
                            totalDomWhite = totalDomWhite + Integer.parseInt(words[13]);
                        } else {
                            unsolvedComponents++;
                        }
                    } else {
                        errorComponents++;
                    }
                }
            }
            
            ArrayList<String> results = new ArrayList();
            
            results.add("Total Components: "+totalComponents);
            results.add("Unsolved Components: "+unsolvedComponents);
            results.add("Total Black Vertices: "+totalBlackVerts);
            results.add("Total White Vertices: "+totalWhiteVerts);
            results.add("Total Edges: "+totalEdges);
            results.add("Total Time: "+totalTime);
            results.add("Total Deletions: "+totalDeletions);
            results.add("Total Insertions: "+totalInsertions);
            results.add("Total Clusters: "+totalClusters);
            results.add("Total Singletons: "+totalSingletons);
            results.add("Total IsolatedEdges: "+totalIsoEdges);
            results.add("Total MonoBlack Clusters: "+totalMonoBlack);
            results.add("Total MonoWhite Clusters: "+totalMonoWhite);
            results.add("Total DomBlack Clusters: "+totalDomBlack);
            results.add("Total DomWhite Clusters: "+totalDomWhite);
            results.add("Error Components: "+errorComponents);
                                
            
            String aggregatedResultOutput = "res/filtered_results/editing_results/aggregatedResults_" + path;
            fileWriter.writeToFile(aggregatedResultOutput, results);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
    
    
    /*
    * Removes accidental space in deletion result file
    *
    * Not needed for new result files
    */  
   public static void FixDeletionMonoWhite(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();
        
        try {
            FileReader fileReaderDeletion = new FileReader("res/filtered_results/deletion_results/" + path+"_deletion");
            BufferedReader bufferedReaderDeletion = new BufferedReader(fileReaderDeletion);

            
            ArrayList<String> linesDeletion = new ArrayList();
            for(String line; (line = bufferedReaderDeletion.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!words[0].contains("%")){  // % signals comments in data sets
                    if(!(words.length==0)){
                            String deletionLineString = ""; 
                            for(int i=0; i<words.length-1; i++){
                                if(i!= 10){
                                    deletionLineString = deletionLineString + words[i]+"\t";
                                }                                
                            }
                            deletionLineString = deletionLineString + words[words.length-1];
                            linesDeletion.add(deletionLineString);

                    } 
                } else {
                    String deletionLineString = ""; 
                    for(int i=0; i<words.length-1; i++){
                        deletionLineString = deletionLineString + words[i]+"\t";
                    }
                    deletionLineString = deletionLineString + words[words.length-1];
                    linesDeletion.add(deletionLineString);
                }
            }
            String OutputFileFilteredDeletion = "res/filtered_results/"+path+"_deletion";
            fileWriter.writeToFile(OutputFileFilteredDeletion, linesDeletion);
            
          
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
   
   
   
    /*
    * Filters result file for BCD so that only components remain that were solved by both variants
    *
    * For ricinus-poplar-1e-80-ocd two components that caused an error for BCE must be deleted manually
    */  
   public static void FilterUnsolvedComponents(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();
        
        try {
            FileReader fileReaderEditing  = new FileReader("res/filtered_results/editing_results/" + path+"_editing");
            FileReader fileReaderDeletion = new FileReader("res/filtered_results/deletion_results/" + path+"_deletion");
            BufferedReader bufferedReaderEditing = new BufferedReader(fileReaderEditing);
            BufferedReader bufferedReaderDeletion = new BufferedReader(fileReaderDeletion);
            
            
            ArrayList<String[]> linesEditing = new ArrayList();
            for(String line; (line = bufferedReaderEditing.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!words[0].contains("%")){  // % signals comments in data sets
                    if(!(words.length==0)){
                        if(words[3].equals("no")){
                            linesEditing.add(words);
                        }                        
                    } 
                }
            }
            
            ArrayList<String> linesDeletion = new ArrayList();
            for(String line; (line = bufferedReaderDeletion.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!words[0].contains("%")){  // % signals comments in data sets
                    if(!(words.length==0)){
                        boolean unsolved = false;                        
                        for(String[] lineEdit : linesEditing){
                            if(words[0].equals(lineEdit[0]) && (words[1].equals(lineEdit[1])) &&  (words[2].equals(lineEdit[2])) ){
                                unsolved = true;                                
                            }
                        }
                        if(unsolved == false){
                            String deletionLineString = ""; 
                            for(int i=0; i<words.length-1; i++){
                                deletionLineString = deletionLineString + words[i]+"\t";
                            }
                            deletionLineString = deletionLineString + words[words.length-1];
                            linesDeletion.add(deletionLineString);
                        }
                    } 
                } else {
                    String deletionLineString = ""; 
                    for(int i=0; i<words.length-1; i++){
                        deletionLineString = deletionLineString + words[i]+"\t";
                    }
                    deletionLineString = deletionLineString + words[words.length-1];
                    linesDeletion.add(deletionLineString);
                }
            }
            String OutputFileFilteredDeletion = "res/filtered_results/filtered_"+path+"_deletion";
            fileWriter.writeToFile(OutputFileFilteredDeletion, linesDeletion);
            
          
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
   
   
    /*
    * Filters result file for BCE so that only components remain that were solved by both variants
    *
    * For ricinus-poplar-1e-80-ocd two components that caused an error for BCE must be deleted manually (empty lines)
    */  
   public static void FilterUnsolvedComponentsEditing(String path){
        
        FileWriter fileWriter = FileWriter.getInstance();
        
        try {
            FileReader fileReaderEditing  = new FileReader("res/filtered_results/editing_results/" + path+"_editing");
            BufferedReader bufferedReaderEditing = new BufferedReader(fileReaderEditing);
            
            
            ArrayList<String> linesEditing = new ArrayList();
            
            for(String line; (line = bufferedReaderEditing.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!words[0].contains("%")){  // % signals comments in data sets
                    if(!(words.length==0)){
                        if(!words[3].equals("no")){
                            String editingLineString = ""; 
                            for(int i=0; i<words.length-1; i++){
                                editingLineString = editingLineString + words[i]+"\t";
                            }
                            editingLineString = editingLineString + words[words.length-1];
                            linesEditing.add(editingLineString);
                        }                        
                    } 
                } else {
                    String editingLineString = ""; 
                    for(int i=0; i<words.length-1; i++){
                        editingLineString = editingLineString + words[i]+"\t";
                    }
                    editingLineString = editingLineString + words[words.length-1];
                    linesEditing.add(editingLineString);
                }
            }
            
          
            String OutputFileFilteredEditing = "res/filtered_results/filtered_"+path+"_editing";
            fileWriter.writeToFile(OutputFileFilteredEditing, linesEditing);
            
          
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
   
   
   
   
    /*
    * Converts a String[] representation of a cluster size histogramm into an Integer[]
    */  
  public static Integer[] readStringArrayAsIntArray(String[] ArrayString){
   int outputSize = 0;
   if(ArrayString[0].contains("[")){
       outputSize = ArrayString.length;
       Integer[] output = new Integer[outputSize];
       Character firstEntry = ArrayString[0].charAt(1);
       output[0] = Character.getNumericValue(firstEntry);
       for(int i=1; i<ArrayString.length; i++){
           Character currentEntry = ArrayString[i].charAt(0);
           output[i] = Character.getNumericValue(currentEntry);
       }
       return output;
   }

   else return new Integer[1];
}
   
   
    /*
    * Aggregates the cluster histogramms for each component from a filtered result file for BCD and returns the result as Integer[]
    */  
 public static ArrayList<Integer[]> aggregateClusterHistogrammDeletion(String path){
        
        try {
            FileReader fileReader = new FileReader("res/filtered_results/deletion_results/filtered_" + path);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            
            ArrayList<Integer[]> histoArrays = new ArrayList();
            for(String line; (line = bufferedReader.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!(words.length==0) && !words[0].contains("%")){  // % signals comments in data sets
                        boolean beginOfHisto = false;
                        ArrayList<String> al = new ArrayList();
                        for(int i = 0; i<words.length; i++){   
                           if(beginOfHisto == false){
                               if(words[i].contains("[")){
                                    beginOfHisto = true;
                                    al.add(words[i]);
                               }
                           }
                           else{
                               if(!words[i].contains("]")){
                                   al.add(words[i]);
                               }
                               else{
                                   al.add(words[i]);
                                   break;
                               }
                           }  
                        }
                        String[] histoString = al.toArray(new String[al.size()]);                        
                        histoArrays.add(readStringArrayAsIntArray(histoString));
                        
                }
            }
            return histoArrays;

        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return new ArrayList<Integer[]>();
    }
 
 
    /*
    * Aggregates the cluster histogramms for each component from a filtered result file for BCE and returns the result as Integer[]
    */  
  public static ArrayList<Integer[]> aggregateClusterHistogrammEditing(String path){
        
        try {
            FileReader fileReader = new FileReader("res/filtered_results/editing_results/filtered_" + path);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            
            ArrayList<Integer[]> histoArrays = new ArrayList();
            for(String line; (line = bufferedReader.readLine()) != null; ){
                String modifiedLine = line.replace("\t", " ");
                String[] words = modifiedLine.split(" ");
                
                if(!(words.length==0) && !words[0].contains("%")){  // % signals comments in data sets
                        boolean beginOfHisto = false;
                        ArrayList<String> al = new ArrayList();
                        for(int i = 0; i<words.length; i++){   
                           if(beginOfHisto == false){
                               if(words[i].contains("[")){
                                    beginOfHisto = true;
                                    al.add(words[i]);
                               }
                           }
                           else{
                               if(!words[i].contains("]")){
                                   al.add(words[i]);
                               }
                               else{
                                   al.add(words[i]);
                                   break;
                               }
                           }  
                        }
                        String[] histoString = al.toArray(new String[al.size()]);
                        histoArrays.add(readStringArrayAsIntArray(histoString));
                }
            }
            return histoArrays;

        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return new ArrayList<Integer[]>();
    }
  
    
    /*
    * Writes the cluster histogramm for BCD to a file
    */  
 public static void writeClusterHistogrammDeletion(String path, ArrayList<Integer[]> histoList){
  
            FileWriter fileWriter = FileWriter.getInstance();
            
            int MaxArraySize = 0;
            for(Integer[] i : histoList){
                if(i.length > MaxArraySize){
                    MaxArraySize = i.length;
                }
            }
            
            int vertexcount = 0;
            
            int[] sumOfHistos = new int[MaxArraySize];
            for(Integer[] currentArr : histoList){
                for(int j = 0; j<currentArr.length; j++){
                    sumOfHistos[j] = sumOfHistos[j]+currentArr[j];
                    vertexcount = vertexcount+(j+1)*currentArr[j];
                }
            }
            
            System.out.println(vertexcount);
            
            
            int vertexcount2 = 0;
            for(int i = 0; i<sumOfHistos.length; i++){
                int addValue = sumOfHistos[i]*(i+1);
                vertexcount2 = vertexcount2 + addValue;
            }
            System.out.println(vertexcount2);
                    
            
            ArrayList<String> output = new ArrayList();
            output.add(Arrays.toString(sumOfHistos));
            
            String OutputFile = "res/filtered_results/DelHistoSum_"+path;
            fileWriter.writeToFile(OutputFile, output);

 
    }
 
 
    /*
    * Writes the cluster histogramm for BCE to a file
    */ 
 public static void writeClusterHistogrammEditing(String path, ArrayList<Integer[]> histoList){
  
            FileWriter fileWriter = FileWriter.getInstance();
            
            int MaxArraySize = 0;
            for(Integer[] i : histoList){
                if(i.length > MaxArraySize){
                    MaxArraySize = i.length;
                }
            }
            
            int vertexcount = 0;
            
            int[] sumOfHistos = new int[MaxArraySize];
            for(Integer[] currentArr : histoList){
                for(int j = 0; j<currentArr.length; j++){
                    sumOfHistos[j] = sumOfHistos[j]+currentArr[j];
                    vertexcount = vertexcount+(j+1)*currentArr[j];
                }
            }
            
            System.out.println(vertexcount);
            
            
            int vertexcount2 = 0;
            for(int i = 0; i<sumOfHistos.length; i++){
                int addValue = sumOfHistos[i]*(i+1);
                vertexcount2 = vertexcount2 + addValue;
            }
            System.out.println(vertexcount2);
                    
            
            ArrayList<String> output = new ArrayList();
            output.add(Arrays.toString(sumOfHistos));
            
            String OutputFile = "res/filtered_results/EditHistoSum_"+path;
            fileWriter.writeToFile(OutputFile, output);

 
    }
    

 
    
    public static void main(String[] args) {
        
//        List<String> dataDeletion = new ArrayList();
//        dataDeletion.add("cacao-poplar-0-ocd.graph_deletion");
//        dataDeletion.add("cacao-poplar-1e-80-ocd.graph_deletion");
//        dataDeletion.add("cacao-poplar-1e-140-ocd.graph_deletion");
//        dataDeletion.add("ricinus-poplar-0-ocd.graph_deletion");
//        dataDeletion.add("ricinus-poplar-1e-80-ocd.graph_deletion");
//        dataDeletion.add("ricinus-poplar-1e-140-ocd.graph_deletion");
//        
//        for(String s : dataDeletion){
//            aggregateDataDeletion(s);
//        }
//        
//        
//
//        List<String> dataEditing = new ArrayList();           
//        dataEditing.add("cacao-poplar-0-ocd.graph_editing");        
////        dataEditing.add("cacao-poplar-1e-80-ocd.graph_editing");
//        dataEditing.add("cacao-poplar-1e-140-ocd.graph_editing");
//        dataEditing.add("ricinus-poplar-0-ocd.graph_editing");
//        dataEditing.add("ricinus-poplar-1e-80-ocd.graph_editing");
//        dataEditing.add("ricinus-poplar-1e-140-ocd.graph_editing");
//
//        for(String s : dataEditing){
//            aggregateDataEditing(s);
//        }
        
        
        
        
        
//        List<String> FilterDataEditing = new ArrayList();
//        
//        FilterDataEditing.add("cacao-poplar-0-ocd.graph");
//        FilterDataEditing.add("cacao-poplar-1e-140-ocd.graph");
//        FilterDataEditing.add("ricinus-poplar-0-ocd.graph");
//        FilterDataEditing.add("ricinus-poplar-1e-80-ocd.graph");
//        FilterDataEditing.add("ricinus-poplar-1e-140-ocd.graph");
//        
//        for(String s : FilterDataEditing){
////            FixDeletionMonoWhite(s);
//            FilterUnsolvedComponents(s);
//        }
//
//        for(String s : FilterDataEditing){
//            FilterUnsolvedComponentsEditing(s);
//        }

            
//        List<String> aggregateFilteredDataDeletion = new ArrayList();
//        aggregateFilteredDataDeletion.add("filtered_cacao-poplar-0-ocd.graph_deletion");
//        aggregateFilteredDataDeletion.add("filtered_cacao-poplar-1e-140-ocd.graph_deletion");
//        aggregateFilteredDataDeletion.add("filtered_ricinus-poplar-0-ocd.graph_deletion");
//        aggregateFilteredDataDeletion.add("filtered_ricinus-poplar-1e-80-ocd.graph_deletion");
//        aggregateFilteredDataDeletion.add("filtered_ricinus-poplar-1e-140-ocd.graph_deletion");
//        
//        for(String s : aggregateFilteredDataDeletion){
//            aggregateFilteredDataDeletion(s);
//        }


       
//        List<String> aggregateFilteredDataEditing = new ArrayList();
//        aggregateFilteredDataEditing.add("filtered_cacao-poplar-0-ocd.graph_editing");
//        aggregateFilteredDataEditing.add("filtered_cacao-poplar-1e-140-ocd.graph_editing");
//        aggregateFilteredDataEditing.add("filtered_ricinus-poplar-0-ocd.graph_editing");
//        aggregateFilteredDataEditing.add("filtered_ricinus-poplar-1e-80-ocd.graph_editing");
//        aggregateFilteredDataEditing.add("filtered_ricinus-poplar-1e-140-ocd.graph_editing");
//        
//        for(String s : aggregateFilteredDataEditing){
//            aggregateFilteredDataEditing(s);
//        }        



        List<String> CluHistoDel = new ArrayList();
        CluHistoDel.add("cacao-poplar-0-ocd.graph_deletion");
        CluHistoDel.add("cacao-poplar-1e-140-ocd.graph_deletion");
        CluHistoDel.add("ricinus-poplar-0-ocd.graph_deletion");
        CluHistoDel.add("ricinus-poplar-1e-140-ocd.graph_deletion");
        CluHistoDel.add("ricinus-poplar-1e-80-ocd.graph_deletion");

        
        for(String s : CluHistoDel){
            ArrayList<Integer[]> clusterHistos = aggregateClusterHistogrammDeletion(s);
            writeClusterHistogrammDeletion(s,clusterHistos);
//            for(Integer[] i : clusterHistos){
//                System.out.println(Arrays.toString(i));
//                for(int j=0; j<i.length; j++){
//                    System.out.print(j+" ");
//                }
//                System.out.println();
//            }
        }


        
        List<String> CluHistoEdit = new ArrayList();
        CluHistoEdit.add("cacao-poplar-0-ocd.graph_editing");
        CluHistoEdit.add("cacao-poplar-1e-140-ocd.graph_editing");
        CluHistoEdit.add("ricinus-poplar-0-ocd.graph_editing");
        CluHistoEdit.add("ricinus-poplar-1e-140-ocd.graph_editing");
        CluHistoEdit.add("ricinus-poplar-1e-80-ocd.graph_editing");

        
        for(String s : CluHistoEdit){
            ArrayList<Integer[]> clusterHistos = aggregateClusterHistogrammEditing(s);
            writeClusterHistogrammEditing(s,clusterHistos);
//            for(Integer[] i : clusterHistos){
//                System.out.println(Arrays.toString(i));
//                for(int j=0; j<i.length; j++){
//                    System.out.print(j+" ");
//                }
//                System.out.println();
//            }
        }
        
    }
    
    
    
}
