

package BCE;

import java.util.*;

public class Edge<K> {
    
    private final Set<Vertex<K>> nodes;
    
    public Edge(Vertex<K> u, Vertex<K> v){
        this.nodes = new HashSet<>();
        this.nodes.add(u);
        this.nodes.add(v);
    }
    
    public Edge(K x, K y){
        this.nodes = new HashSet<>();
        Vertex<K> u = new Vertex(x);   
        Vertex<K> v = new Vertex(y);
        this.nodes.add(u);
        this.nodes.add(v);
    }
    
    public Set<Vertex<K>> getNodes(){
        return nodes;
    }
    
    public Vertex<K>[] getNodeArray(){
        Vertex<K>[] vertices = new Vertex[2];
        return nodes.toArray(vertices);
    }
    
    @Override
    public String toString() {
        Vertex<K>[] nodes = this.getNodeArray();
        String output = "{";
        output += nodes[0]+","+nodes[1];
        output += "}";
        return output;
    }
    
    @Override
    public boolean equals(Object other){
        if(other == this){
            return true;
        }
        if(!(other instanceof Edge)){
            return false;
        } else {
            Edge<K> other_ = (Edge<K>) other;
            return other_.getNodes().equals(this.nodes);
        }
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((nodes==null) ? 0 : nodes.hashCode());
        return result;
    }
}
