
package BCE;

import java.util.Objects;

public class Tuple<X,Y>{
    public final X x;
    public final Y y;
    public Tuple(X x, Y y){
        this.x = x;
        this.y = y;
    }
    
    @Override
    public String toString() {
        return "( " + x + "," + y + " )";
    }
    
    public X getFirst(){
        return this.x;
    }
    public Y getSecond(){
        return this.y;
    }
    
    @Override
    public boolean equals(Object other){
        if(other == this){
            return true;
        }
        if(!(other instanceof Tuple)){
            return false;
        } else {
            Tuple<X,Y> other_ = (Tuple<X,Y>) other;
            return Objects.equals(this.x, other_.x) && Objects.equals(this.y,other_.y);
        }
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((x==null) ? 0 : x.hashCode());
        result = prime * result + ((y==null) ? 0 : y.hashCode());
        return result;
    }
}
