
package BCE;

import java.util.*;


public class Vertex<K> {
    
    private K value;
    private String color;
    
    public Vertex(K value){
        this.value = value;
        this.color = "null";
    }
    
    public Vertex(K value, String color){
        this.value = value;
        this.color = color;
    }
    
    public Boolean isBlack(){
        return "b".equals(this.color);
    }
    
    public Boolean isWhite(){
        return "w".equals(this.color);
    }
    
    public K getValue(){
        return this.value;
    }
    
    public void setColor(String color){
        this.color = color;
    }
    
    public String getColor(){
        return this.color;
    }
    
    
    @Override
    public String toString() {
        return "(" + value.toString() + "," + color + ")";
    }
    
    @Override
    public boolean equals(Object other){
        if(other == this){
            return true;
        }
        if(!(other instanceof Vertex)){
            return false;
        } else {
            Vertex<K> other_ = (Vertex<K>) other;
            return other_.getValue().equals(this.value);
        }
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((value==null) ? 0 : value.hashCode());
        return result;
    }
    
}
