
package tests;


import BCE.Tuple;
import BCE.ILPs;
import BCE.Graph;
import BCE.GraphImport;
import BCE.Edge;
import BCE.Vertex;
import java.util.*;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import org.junit.Before;
import org.junit.Test;


public class ILPTest {
    
    
    ILPs<String> ILPString;
    ILPs<Integer> ILPInt;
    Graph<String> G;
    Graph<String> H;
    Graph<Integer> I;
    Graph<Integer> J;
    Graph<Integer> K;
    Graph<String> C;
    GraphImport importer = GraphImport.getInstance();
    
    @Before
    public void setUp(){
        Set<Vertex<Integer>> vertices = new HashSet();
        Vertex<Integer> v1 = new Vertex(1,"b");
        Vertex<Integer> v2 = new Vertex(2,"b");
        Vertex<Integer> v3 = new Vertex(3,"w");
        Vertex<Integer> v4 = new Vertex(4,"w");
        vertices.add(v1);
        vertices.add(v2);
        vertices.add(v3);
        vertices.add(v4); 
        K = new Graph(vertices);
        K.addEdge(v1,v2);
        K.addEdge(v1,v3);
        K.addEdge(v1,v4);
        K.addEdge(v2,v3);
        K.addEdge(v2,v4);
        K.addEdge(v3,v4);
    }
    
    @Test 
    public void ILPsTest(){
        ILPString = new ILPs();
        ILPInt = new ILPs();
       
        G = importer.readGraphString("res/paw_graph");
        Tuple<Set<Edge<String>>,String> resultG = ILPString.solveBCE(G);
        for(Edge<String> e : resultG.getFirst()){
             System.out.println(e);
        }
        
        H = importer.readGraphString("res/test_graph.txt");
        Tuple<Set<Edge<String>>,String> resultH = ILPString.solveBCE(H);
        for(Edge<String> e : resultH.getFirst()){
             System.out.println(e);
        }    
        
    
//        H = importer.readGraphString("res/paw_graph");
//        System.out.println(H);
//        Tuple<Set<Edge<String>>,String> resultH = ILPString.solveBCD(H);
//        for(Edge<String> e : resultH.getFirst()){
//             System.out.println(e);
//        } 
        
        
       
//        H = importer.readBicoloredGraphString("res/colorTest_graph.txt");
//        System.out.println(H);
//        Tuple<Set<Edge<String>>,String> resultH = ILPString.solveBCD(H);
//        for(Edge<String> e : resultH.getFirst()){
//             System.out.println(e);
//        } 
    
    
    
//        I = G.createTestGraph(3, 30, 20);
//      //  System.out.println("Testgraph: \n"+I);
//        Set<Edge<Integer>> resultI = ILPInt.solveBCE(I);
//        for(Edge<Integer> e : resultI){
//          //   System.out.println(e);
//        }   
//        
//        J = I.distortGraph(600, 20);
//    //    System.out.println("Testgraph with distortions: \n"+J);
//        Set<Graph> components = J.getConnectedComponents();
//        for(Graph g : components){
//                System.out.println("Component of size "+g.getVertices().size());
//                System.out.println(g);
//                Set<Edge<Integer>> subsol = ILPInt.solveBCD(g);
//        }
     //   Set<Edge<Integer>> resultJ = ILPInt.solveBCD(J);
     /*   for(Edge<Integer> e : resultJ){
             System.out.println(e);
        }
        */
   
        /*
        Set<Edge<Integer>> resultK = ILPInt.solveBCE(K);
        for(Edge<Integer> e : resultK){
       //      System.out.println(e);
        }
        */
  
        /*
        C = importer.readGraphString("res/circle_graph.txt");
        Set<Edge<String>> resultC = ILPString.solveBCE(C);
        */
    }
    
}
